// MyWin.cpp : implementation file
//

#include "stdafx.h"
#include "float.h"
#include "MyWin.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMyWin

CMyWin::CMyWin(CWnd* pW):COGLWnd(pW)
{
	// Window is created and we can 
	// set up the drawing environment

	SetUpDrawingEnvironment();
	ASSERT(m_hRC !=NULL);

	// do one-time initializing
	InitializeRContext();

	// set mousing around variables
	m_Vx=m_Vy=0.0f;
}

CMyWin::~CMyWin()
{
}


BEGIN_MESSAGE_MAP(CMyWin, COGLWnd)
	//{{AFX_MSG_MAP(CMyWin)
	ON_WM_SIZE()
	ON_WM_MOUSEMOVE()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CMyWin message handlers
void CMyWin::DrawScene()
{
	// calc the viewing box according to
	// the scene you want to see
	GLfloat dx=1.5f;
	GLfloat dy=1.5f;
	// set the view
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
	glOrtho(-dx,dx,-dy,dy,0.0f,100.0f);
	glMatrixMode(GL_MODELVIEW);

	// Clear the color and depth buffers.
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();

	// looking down negative z
	glTranslatef(0.0f,0.0f,-5.0f);

	// tilt it around x
	glRotatef(m_Vx,1.0f,0.0f,0.0f);
	// tilt it around y
	glRotatef(m_Vy,0.0f,1.0f,0.0f);

	CMaterial::SetMaterial(EMERALD);

	m_logo.DrawLogo();

	
	// finnish drawing
	glFlush();
}

void CMyWin::InitializeRContext()
{
	COGLWnd::InitializeRContext();
    // (re)set background to white
	glClearColor(1.0f, 1.0f, 1.0f, 0.0f);
}

void CMyWin::OnSize(UINT nType, int cx, int cy) 
{
	glViewport(0, 0, cx, cy);
	m_PLast.x=cx/2;
	m_PLast.y=cy/2;

	CWnd::OnSize(nType, cx, cy);
}

void CMyWin::OnDestroy() 
{
	COGLWnd::OnDestroy();
}

void CMyWin::OnMouseMove(UINT nFlags, CPoint point) 
{
	m_Vy=m_Vy+GLfloat(m_PLast.x-point.x);
	m_Vx=m_Vx+GLfloat(m_PLast.y-point.y);
	m_PLast=point;
	RedrawWindow();
}
