//-------------------------------
// NOHouse.cpp : implementation file
//

#include "stdafx.h"
#include "village.h"
#include "NOHouse.h"


//----------------------------------
// a helper
void DrawATree(GLfloat height)
{
	// need a quadric to construct stem and cone
	GLUquadricObj *glpQ;
	glpQ=gluNewQuadric();

	// brown stem
	GLfloat amb[]={0.91f,0.44f,0.38f,1.0f};
	GLfloat dif[]={0.38f,0.32f,0.03f,1.0f};
	GLfloat spec[]={0.01f,0.01f,0.01f,1.0f};
	GLfloat shine=1.0f;
	glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT,amb);
	glMaterialfv(GL_FRONT_AND_BACK,GL_DIFFUSE,dif);
	glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,spec);
	glMaterialf(GL_FRONT_AND_BACK,GL_SHININESS,shine);		
	
	gluCylinder(glpQ,0.1f,0.1f,height*0.2f,10,1);
	glTranslatef(0.0f,0.0f,height*0.2f);
	// green cone
	GLfloat amb1[]={0.35f,1.0f,0.22f,1.0f};
	GLfloat dif1[]={0.07f,1.0f,0.13f,1.0f};
	GLfloat spec1[]={0.01f,0.01f,0.01f,1.0f};
	GLfloat shine1=1.0f;
	glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT,amb1);
	glMaterialfv(GL_FRONT_AND_BACK,GL_DIFFUSE,dif1);
	glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,spec1);
	glMaterialf(GL_FRONT_AND_BACK,GL_SHININESS,shine1);		
	gluCylinder(glpQ,0.5f,0.0f,height*0.8f,10,1);

	gluDeleteQuadric(glpQ);

}

IMPLEMENT_DYNCREATE(NOHouse, house)


NOHouse::NOHouse(GLfloat x,GLfloat y)
	: house(x,y)
{
	static long step=1213;
	// set randseed som we get same look in each draw
	// use time to get a starting point
	CTime t=CTime::GetCurrentTime();
	randseed=t.GetTime()+step;
	step*=2;
}

NOHouse::NOHouse()
:house()
{
}

void NOHouse::Draw()
{

	//------------------------------
	// Remember origo, so we can set it 
	// back when we finish drawing
	glPushMatrix();
	// set origo in areas corner
	glTranslatef(origo_X,origo_Y,0.0f);

	//------------------------------
	// reconstruct start of random sequence:
	srand(randseed);

	// decide number of trees (3..10)
	int treecount=7+((int)(rand()*10))%7;

	// make the trees
	for(int ix=0;ix<treecount;ix++)
	{
		// decide position
		GLfloat  x=1.0f+((int)(rand()*100))%19;
		GLfloat  y=1.0f+((int)(rand()*100))%19;
		// make this tree
		glPushMatrix();
		glTranslatef(x,y,0.0f);
		DrawATree(4.0f+((int)(rand()*100))%10);
		glPopMatrix();

	}

	//------------------
	// set back origo to where it was when we 
	// entered this function
	glPopMatrix();
}
void NOHouse::DrawOutline()
{
	// make a fast outline
	// the trees are replaced by simple lines
	//------------------------------
	// Remember origo, so we can set it 
	// back when we finish drawing
	glPushMatrix();
	// set origo in areas corner
	glTranslatef(origo_X,origo_Y,0.0f);

	//------------------------------
	// reconstruct start of random sequence:
	srand(randseed);

	// decide number of trees (3..10)
	int treecount=3+((int)(rand()*10))%7;

	// make the trees
	for(int ix=0;ix<treecount;ix++)
	{
		// decide position
		GLfloat  x=1.0f+((int)(rand()*100))%19;
		GLfloat  y=1.0f+((int)(rand()*100))%19;
		// make this tree
		glLineWidth(2);
		glBegin(GL_LINES);
		CMaterial::SetMaterial(BLACK_PLASTIC);
		glVertex3f(x,y,0.0f);
		glVertex3f(x,y,1.0f+((int)(rand()*100))%10);
		glEnd();
		glLineWidth(1);
	}

	//------------------
	// set back origo to where it was when we 
	// entered this function
	glPopMatrix();
}

BOOL NOHouse:: PickAction()
{
	return FALSE;
}


