//-------------------------------
// CMyScene is the basic sceneoperator for a village
// with an unknown number of houses
// Functionlity:
//	DrawScene - displays the village
//  InitializeRContext- setup of one-time OGL stuff
//  SetSize-sets up the lens we look through
//  SetUpVillage- reads a string and builds a village accordingly
//  EraseVillage-clears the village
// Members:
//	m_Max_x,m_Max_y-calculated extent of the village
//	m_pHouse-list of houses, all subcallse from class house
//  m_Vx,m_Vy,m_PLast-variables to keep track of the mousing;
//	m_bOutline-flags wheter we shall render complete or outline;
//  m_VLens-angle used in perspective projecytion
// b.stenseth, nov 2000


#if !defined(AFX_MYWIN_H__4F952B1A_80E3_11D1_B06C_0060082D402F__INCLUDED_)
#define AFX_MYWIN_H__4F952B1A_80E3_11D1_B06C_0060082D402F__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// MyWin.h : header file
//
#include "oglwnd.h"
#include "stdafx.h"

/////////////////////////////////////////////////////////////////////////////
// CMyWin window

class CMyScene : public COGLWnd
{
// Construction
public:
	CMyScene(CWnd* pW);

// Attributes
public:
	// describing the village's extent
	GLfloat m_Max_x,m_Max_y;
	// the houses
	CPtrArray m_pHouse;

	// mousing around
	GLfloat m_Vx,m_Vy;
	CPoint m_PLast;
	// outline or full draw
	BOOL m_bOutline;
	// lens, angle in perspective projection
	GLfloat m_VLens;


// Operations
public:
	virtual void DrawScene();
	virtual void InitializeRContext();
	virtual void SetSize(int cx, int cy);

	void SetUpVillage(CString T);
	void EraseVillage();


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMyWin)
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMyScene();

	// Generated message map functions
protected:
	//{{AFX_MSG(CMyWin)
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnDestroy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MYWIN_H__4F952B1A_80E3_11D1_B06C_0060082D402F__INCLUDED_)
