// villageView.cpp : implementation of the CVillageView class
//

#include "stdafx.h"
#include "village.h"

#include "villageDoc.h"
#include "villageView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVillageView

IMPLEMENT_DYNCREATE(CVillageView, CFormView)

BEGIN_MESSAGE_MAP(CVillageView, CFormView)
	//{{AFX_MSG_MAP(CVillageView)
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_BUT_UPDATE, OnButUpdate)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVillageView construction/destruction

CVillageView::CVillageView()
	: CFormView(CVillageView::IDD)
{
	//{{AFX_DATA_INIT(CVillageView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// TODO: add construction code here

	m_pW=NULL;

}

CVillageView::~CVillageView()
{
	if(m_pW!=NULL)
		delete (CMyScene*)m_pW;
}

void CVillageView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVillageView)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BOOL CVillageView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

void CVillageView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit();

	// establish the opengl window
	// makes its own rendering context
	// and use it while while it lives
	m_pW=new CMyScene(this);

	// expand it as much as possible
	SetMySceneSize();

	// set up available houses text
	// value set in CMyScene - constructor
	CWnd* pW=GetDlgItem(IDC_STATIC_AVAILABLE);
	pW->SetWindowText(g_strAvailableHouses);

}

/////////////////////////////////////////////////////////////////////////////
// CVillageView diagnostics

#ifdef _DEBUG
void CVillageView::AssertValid() const
{
	CFormView::AssertValid();
}

void CVillageView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CVillageDoc* CVillageView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CVillageDoc)));
	return (CVillageDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CVillageView message handlers

void CVillageView::OnSize(UINT nType, int cx, int cy) 
{
	CFormView::OnSize(nType, cx, cy);
	if(m_pW!=NULL)
		SetMySceneSize();
	
}


void CVillageView::SetMySceneSize()
{
	// leave edit box untouched and place my 
	// openGL scene to the right and on top

	CRect r_Edit,r_All;
	int margin;
	// screen coordinates
	GetDlgItem(IDC_EDIT1)->GetWindowRect(&r_Edit);
	GetClientRect(&r_All);
	
	// to view window to pick up the margin used
	ScreenToClient(r_Edit);
	margin=r_Edit.left;

	m_pW->SetWindowPos(&wndTop,
						margin*2+r_Edit.Width(),
						margin,
						r_All.Width()-(r_Edit.Width()+3*margin),
						r_All.Height()-2*margin,
						NULL);
	m_pW->ShowWindow(SW_SHOW);
	
	((COGLWnd*)m_pW)->SetSize(	r_All.Width()-(r_Edit.Width()+3*margin),
								r_All.Height()-2*margin);

}

void CVillageView::OnButUpdate() 
{
	// pick up te text from the edit window
	// and ask the sceneview to parse it
	CString S=_T("");
	GetDlgItem(IDC_EDIT1)->GetWindowText(S);
	((CMyScene*)m_pW)->SetUpVillage(S);

}
